# remirepo/Fedora spec file for php-zendframework-zend-session
#
# Copyright (c) 2015-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    8fd50220888167d08cf0113ced5b023f6da06923
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-session
%global php_home     %{_datadir}/php
%global library      Session
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.8.7
Release:        2%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-date
BuildRequires:  php-hash
BuildRequires:  php-pcre
BuildRequires:  php-session
BuildRequires:  php-spl
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires:  (php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2 with php-autoloader(%{gh_owner}/zend-eventmanager)   <  4)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)         <  4)
# remirepo:6
%else
BuildRequires:   php-autoloader(%{gh_owner}/zend-eventmanager)   <  4
BuildRequires:   php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2
BuildRequires:   php-autoloader(%{gh_owner}/zend-stdlib)         <  4
BuildRequires:   php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
%endif
# From composer, "require-dev": {
#        "container-interop/container-interop": "^1.1",
#        "mongodb/mongodb": "^1.0.1",
#        "php-mock/php-mock-phpunit": "^1.1.2 || ^2.0",
#        "phpunit/phpunit": "^5.7.5 || >=6.0.13 <6.5.0",
#        "zendframework/zend-cache": "^2.6.1",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-db": "^2.7",
#        "zendframework/zend-http": "^2.5.4",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-validator": "^2.6"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires:  (php-composer(container-interop/container-interop) >= 1.1    with php-composer(container-interop/container-interop) < 2)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-cache)            >= 2.6.1  with php-autoloader(%{gh_owner}/zend-cache)            < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-db)               >= 2.7    with php-autoloader(%{gh_owner}/zend-db)               < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-http)             >= 2.5.4  with php-autoloader(%{gh_owner}/zend-http)             < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-servicemanager)   >= 2.7.5  with php-autoloader(%{gh_owner}/zend-servicemanager)   < 4)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-validator)        >= 2.6    with php-autoloader(%{gh_owner}/zend-validator)        < 3)
# remirepo:9
%else
BuildRequires:   php-composer(container-interop/container-interop) <  2
BuildRequires:   php-composer(container-interop/container-interop) >= 1.1
BuildRequires:   php-autoloader(%{gh_owner}/zend-cache)            >= 2.6.1
BuildRequires:   php-autoloader(%{gh_owner}/zend-db)               >= 2.7
BuildRequires:   php-autoloader(%{gh_owner}/zend-http)             >= 2.5.4
BuildRequires:   php-autoloader(%{gh_owner}/zend-servicemanager)   >= 2.7.5
BuildRequires:   php-autoloader(%{gh_owner}/zend-validator)        >= 2.6
%endif
BuildRequires:   phpunit6
BuildRequires:   php-mock-phpunit2 >= 2.1.0
%endif
# Autoloader
BuildRequires:   php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:       (php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2 with php-autoloader(%{gh_owner}/zend-eventmanager)   <  4)
Requires:       (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)         <  4)
# remirepo:6
%else
Requires:        php-autoloader(%{gh_owner}/zend-eventmanager)   <  4
Requires:        php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2
Requires:        php-autoloader(%{gh_owner}/zend-stdlib)         <  4
Requires:        php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
%endif
# From composer, "suggest": {
#        "mongodb/mongodb": "If you want to use the MongoDB session save handler"
#        "zendframework/zend-cache": "Zend\\Cache component",
#        "zendframework/zend-db": "Zend\\Db component",
#        "zendframework/zend-http": "Zend\\Http component",
#        "zendframework/zend-servicemanager": "Zend\\ServiceManager component",
#        "zendframework/zend-validator": "Zend\\Validator component"
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 8
Suggests:       php-composer(mongodb/mongodb)
Suggests:       php-autoloader(%{gh_owner}/zend-cache)
Suggests:       php-autoloader(%{gh_owner}/zend-db)
Suggests:       php-autoloader(%{gh_owner}/zend-http)
Suggests:       php-autoloader(%{gh_owner}/zend-servicemanager)
Suggests:       php-autoloader(%{gh_owner}/zend-validator)
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.8.0
Requires:       php-date
Requires:       php-hash
Requires:       php-pcre
Requires:       php-session
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Session is a component to manage PHP session using an object
oriented interface.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Generate autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/EventManager/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/MongoDB/autoload.php',
    '%{php_home}/Zend/Cache/autoload.php',
    '%{php_home}/Zend/Db/autoload.php',
    '%{php_home}/Zend/Http/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
# this test requires a running MongoDB server
rm test/SaveHandler/MongoDBTest.php

mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/phpmock2/phpunit/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
require_once __DIR__ . '/../test/autoload.php';
EOF

ret=0
for cmd in php php71 php72 php73 php74; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit6 \
      --filter '^((?!(testConfigurationWithoutInputIsValid)).)*$' \
      --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
# remirepo:1
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Fri Sep 20 2019 Remi Collet <remi@remirepo.net> - 2.8.7-2
- update to 2.8.7

* Tue Aug 20 2019 Remi Collet <remi@remirepo.net> - 2.8.6-2
- update to 2.8.6

* Thu Dec  6 2018 Remi Collet <remi@remirepo.net> - 2.8.5-3
- cleanup for EL-8

* Fri Mar 23 2018 Remi Collet <remi@remirepo.net> - 2.8.5-2
- switch to phpunit6 and php-mock2

* Fri Feb 23 2018 Remi Collet <remi@remirepo.net> - 2.8.5-1
- Update to 2.8.5 (no change)
- use range dependencies on F27+

* Thu Feb  1 2018 Remi Collet <remi@remirepo.net> - 2.8.4-1
- Update to 2.8.4

* Mon Dec 11 2017 Remi Collet <remi@remirepo.net> - 2.8.3-2
- switch from zend-loader to fedora/autoloader

* Mon Dec  4 2017 Remi Collet <remi@remirepo.net> - 2.8.3-1
- Update to 2.8.3

* Thu Nov 30 2017 Remi Collet <remi@remirepo.net> - 2.8.2-1
- Update to 2.8.2
- only use PHPUnit 5 and php-mock-phpunit v1
  as PHPUnit 6 requires php-mock-phpunit v2 not available

* Wed Nov 29 2017 Remi Collet <remi@remirepo.net> - 2.8.1-1
- Update to 2.8.1

* Wed Nov  8 2017 Remi Collet <remi@remirepo.net> - 2.8.0-3
- fix FTBFS from Koschei, ignore 1 test with PHP 7.2

* Tue Jun 20 2017 Remi Collet <remi@remirepo.net> - 2.8.0-1
- Update to 2.8.0
- raise dependency on PHP 5.6
- use phpunit6 on F26+

* Wed Nov 30 2016 Remi Collet <remi@fedoraproject.org> - 2.7.3-2
- fix FTBFS, ignore failed test with PHP 7.1
  open https://github.com/zendframework/zend-session/issues/68

* Wed Jul  6 2016 Remi Collet <remi@fedoraproject.org> - 2.7.3-1
- update to 2.7.3

* Sat Jun 25 2016 Remi Collet <remi@fedoraproject.org> - 2.7.2-1
- update to 2.7.2

* Wed May 11 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Tue Apr 12 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0
- add optional dependency on mongodb/mongodb

* Fri Feb 26 2016 Remi Collet <remi@fedoraproject.org> - 2.6.2-1
- update to 2.6.2

* Wed Feb 24 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Tue Feb 23 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on zend-eventmanager >= 2.6.2
- raise dependency on zend-stdlib >= 2.7

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- initial package
